﻿using C1.TextParser;
using C1_hl7.wpf.ViewModels;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace C1_hl7.wpf
{

    /// <summary>
    /// Interaction logic for TestExtractor.xaml
    /// </summary>
    public partial class TestExtractor : Window
    {
        private readonly ExtractorViewModel _extractorViewModel = new();

        public TestExtractor()
        {
            InitializeComponent();
            DataContext = _extractorViewModel;
            _extractorViewModel.Hl7Data = File.ReadAllText(@"Data\ADT_A04.hl7");
            _extractorViewModel.Template = File.ReadAllText(@"Templates\HL7Template.xml");
        }

        private void Extract_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                using MemoryStream hl7 = new MemoryStream(Encoding.ASCII.GetBytes(_extractorViewModel.Hl7Data));
                using MemoryStream template = new MemoryStream(Encoding.ASCII.GetBytes(_extractorViewModel.Template));

                TemplateBasedExtractor templateBasedExtractor = new TemplateBasedExtractor(template);
                IExtractionResult extractionResult = templateBasedExtractor.Extract(hl7);
                _extractorViewModel.Json = extractionResult.ToJsonString();
            }
            catch (Exception ex)
            {
                _extractorViewModel.Json = ex.ToString();
            }
        }
    }
}
