﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Linq;

namespace C1_hl7.wpf.ViewModels
{
    class ExtractorViewModel : INotifyPropertyChanged
    {
        private string _hl7Data = string.Empty;
        private string _template = string.Empty;
        private string _json = string.Empty;

        public event PropertyChangedEventHandler PropertyChanged;

        public string Hl7Data 
        {
            get => _hl7Data;
            set
            {
                if (_hl7Data != value)
                {
                    _hl7Data = value;
                    NotifyPropertyChanged();
                }
            }
        }
        public string Template
        {
            get => _template;
            set
            {
                if (_template != value)
                {
                    _template = value;
                    NotifyPropertyChanged();
                }
            }
        }
        public string Json
        {
            get => _json;
            set
            {
                if (_json != value)
                {
                    _json = value;
                    NotifyPropertyChanged();
                }
            }
        }

        public void NotifyPropertyChanged([CallerMemberName] string propName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propName));
        }
    }
}
